//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "Unit2.h"
#include "Unit3.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
bool WriteTo()
{DWORD temp;

 WriteFile(Port,wr_buf,wr_buf_len,&temp,&ovr_wr); //   
 WaitForSingleObject(ovr_wr.hEvent,30000);        //   30         
 if(GetOverlappedResult(Port,&ovr_wr,&temp,true)) return true;  //    -  
 else                                             return false; //  - 
}
//---------------------------------------------------------------------------
bool ReadFrom()
{ COMSTAT    port_status;
  DWORD      temp, mask;
  int        Counter;

 Counter=0;
 while(Counter<1000) //   1000 
 { ClearCommError(Port,&temp,&port_status);    //  port_status
   rd_buf_len=0;
   rd_buf_len=port_status.cbInQue;  //-  
   if(rd_buf_len>0) //    
   { ReadFile(Port,rd_buf,rd_buf_len,&temp,&ovr_rd);  //  - 
     return true;
   }
   Counter++;
   Sleep(1);
 }
 return false;
}
//---------------------------------------------------------------------------
void OpenPort()
{ dcb.DCBlength=sizeof(DCB);
  //  .     nt-  
  // "\\.\PortName",      \    2 
  char PortName[100]="\\\\.\\";
  strcat(PortName,Form1->ComboBox1->Text.c_str());
  Port=CreateFile(PortName,GENERIC_READ|GENERIC_WRITE,0,NULL,OPEN_EXISTING,FILE_FLAG_OVERLAPPED,NULL);
  if(Port==INVALID_HANDLE_VALUE)
  { MessageBox(NULL,"  ","Error",MB_OK);
    return;
  }
  else
  { if(GetCommState(Port,&dcb)==0)
    { MessageBox(NULL,"   ","Error",MB_OK);
      CloseHandle(Port);
      Port=INVALID_HANDLE_VALUE;
      return;
    }
    else
    { dcb.BaudRate=115200;
      dcb.ByteSize=8;
      dcb.Parity=0;
      dcb.StopBits=2;
      dcb.fBinary=true;          //  
      dcb.fOutxCtsFlow=false;    //  CTS
      dcb.fOutxDsrFlow=false;    //  DSR
      dcb.fDtrControl=DTR_CONTROL_DISABLE;     // DTR
      dcb.fDsrSensitivity=false;               //  DSR
      dcb.fNull=false;           //  
      dcb.fRtsControl=RTS_CONTROL_DISABLE;    // RTS
      dcb.fAbortOnError=false;   //  /  
   }
   if(SetCommState(Port,&dcb)==0)
   { MessageBox(NULL,"   ","Error",MB_OK);
     CloseHandle(Port);
     Port=INVALID_HANDLE_VALUE;
     return;
   }

   memset(wr_buf,0,BUFSIZE);        //    
   wr_buf_len=0;                    //  
   SetupComm(Port,BUFSIZE+100,BUFSIZE+100);       //    
   PurgeComm(Port,PURGE_RXCLEAR|PURGE_TXCLEAR);   //     

   Form1->Button1->Enabled=true;
   Form1->Button2->Enabled=true;
   Form1->Button3->Enabled=false;
   Form1->Button4->Enabled=true;
   Form1->Button5->Enabled=true;
   Form1->Button6->Enabled=true;
   Form1->Button7->Enabled=true;
   Form1->Button8->Enabled=true;
   Form1->CheckBox1->Enabled=true;
   Form1->CheckBox2->Enabled=true;
   Form1->CheckBox3->Enabled=true;

   //  
   wr_buf_len=3;
   wr_buf[0]=0x0A;     // disable autoload
   wr_buf[1]=0x08;     // disable reports
   wr_buf[2]=0x03;     // select 1W
   if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                    ClosePort();
                    return;
                  }
  }
}
//---------------------------------------------------------------------------
void ClosePort()
{ CloseHandle(Port);
  Port=INVALID_HANDLE_VALUE;
  Form1->Button1->Enabled=false;
  Form1->Button2->Enabled=false;
  Form1->Button3->Enabled=true;
  Form1->Button4->Enabled=false;
  Form1->Button5->Enabled=false;
  Form1->Button6->Enabled=false;
  Form1->Button7->Enabled=false;
  Form1->Button8->Enabled=false;
  Form1->CheckBox1->Enabled=false;
  Form1->CheckBox1->Checked=false;
  Form1->CheckBox2->Enabled=false;
  Form1->CheckBox2->Checked=false;
  Form1->CheckBox3->Enabled=false;
  Form1->CheckBox3->Checked=false;
}
//---------------------------------------------------------------------------
void BuildDataMemory()
{ int i;
  switch(PageToUpdate)
  { case 1: //  1
            Form1->RichEdit1->Clear(); Form1->RichEdit1->Visible=false;
            for(i=0; i<(SelectedChip.Size-1)/8+1 ; i++)
              Form1->RichEdit1->Lines->Add(IntToHex(8*i,4)+": FF FF FF FF FF FF FF FF   |   ");
            //     
            Form1->RichEdit1->SelStart=46*(i-1)+44;
            Form1->RichEdit1->SelLength=2;
            Form1->RichEdit1->SelText="";
            //   
            Form1->RichEdit1->Visible=true;
            break;
    case 2: //  2
            Form1->RichEdit2->Clear(); Form1->RichEdit2->Visible=false;
            for(i=0; i<(SelectedChip.Size-1)/8+1 ; i++)
              Form1->RichEdit2->Lines->Add(IntToHex(8*i,4)+": FF FF FF FF FF FF FF FF   |   ");
            //     
            Form1->RichEdit2->SelStart=46*(i-1)+44;
            Form1->RichEdit2->SelLength=2;
            Form1->RichEdit2->SelText="";
            //   
            Form1->RichEdit2->Visible=true;
            break;
    case 3: //  3
            Form1->RichEdit3->Clear(); Form1->RichEdit3->Visible=false;
            for(i=0; i<(SelectedChip.Size-1)/8+1 ; i++)
              Form1->RichEdit3->Lines->Add(IntToHex(8*i,4)+": FF FF FF FF FF FF FF FF   |   ");
            //     
            Form1->RichEdit3->SelStart=46*(i-1)+44;
            Form1->RichEdit3->SelLength=2;
            Form1->RichEdit3->SelText="";
            //   
            Form1->RichEdit3->Visible=true;
            break;
    default://  1,2,3
            Form1->RichEdit1->Clear(); Form1->RichEdit1->Visible=false;
            Form1->RichEdit2->Clear(); Form1->RichEdit2->Visible=false;
            Form1->RichEdit3->Clear(); Form1->RichEdit3->Visible=false;

            for(i=0; i<(SelectedChip.Size-1)/8+1 ; i++)
            { Form1->RichEdit1->Lines->Add(IntToHex(8*i,4)+": FF FF FF FF FF FF FF FF   |   ");
              Form1->RichEdit2->Lines->Add(IntToHex(8*i,4)+": FF FF FF FF FF FF FF FF   |   ");
              Form1->RichEdit3->Lines->Add(IntToHex(8*i,4)+": FF FF FF FF FF FF FF FF   |   ");
            }
            //     
            Form1->RichEdit1->SelStart=46*(i-1)+44;
            Form1->RichEdit1->SelLength=2;
            Form1->RichEdit1->SelText="";

            Form1->RichEdit2->SelStart=46*(i-1)+44;
            Form1->RichEdit2->SelLength=2;
            Form1->RichEdit2->SelText="";

            Form1->RichEdit3->SelStart=46*(i-1)+44;
            Form1->RichEdit3->SelLength=2;
            Form1->RichEdit3->SelText="";
            //   
            Form1->RichEdit1->Visible=true;
            Form1->RichEdit2->Visible=true;
            Form1->RichEdit3->Visible=true;
  }
  Form1->Edit1->Text=SelectedChip.Name; PageToUpdate=0;
}
//---------------------------------------------------------------------------
void BuildARegMemory()
{ switch(PageToUpdate)
  { case 1: //  1
            Form1->RichEdit4->Clear();
            Form1->RichEdit4->Visible=false;
            Form1->RichEdit4->Lines->Add(IntToHex(0,4)+": FF FF FF FF FF FF FF FF   |   ");
            //     
            Form1->RichEdit4->SelStart=44;
            Form1->RichEdit4->SelLength=2;
            Form1->RichEdit4->SelText="";
            //  Status Register
            Form1->Edit4->Text="FF";
            //  
            Form1->RichEdit4->Visible=true;
            break;
    case 2: //  2
            Form1->RichEdit5->Clear();
            Form1->RichEdit5->Visible=false;
            Form1->RichEdit5->Lines->Add(IntToHex(0,4)+": FF FF FF FF FF FF FF FF   |   ");
            //     
            Form1->RichEdit5->SelStart=44;
            Form1->RichEdit5->SelLength=2;
            Form1->RichEdit5->SelText="";
            //  Status Register
            Form1->Edit5->Text="FF";
            //  
            Form1->RichEdit5->Visible=true;
            break;
    case 3: //  3
            Form1->RichEdit6->Clear();
            Form1->RichEdit6->Visible=false;
            Form1->RichEdit6->Lines->Add(IntToHex(0,4)+": FF FF FF FF FF FF FF FF   |   ");
            //     
            Form1->RichEdit6->SelStart=44;
            Form1->RichEdit6->SelLength=2;
            Form1->RichEdit6->SelText="";
            //  Status Register
            Form1->Edit6->Text="FF";
            //  
            Form1->RichEdit6->Visible=true;
            break;
    default://  1,2,3
            Form1->RichEdit4->Clear(); Form1->RichEdit5->Clear(); Form1->RichEdit6->Clear();
            Form1->RichEdit4->Visible=false; Form1->RichEdit5->Visible=false; Form1->RichEdit6->Visible=false;

            Form1->RichEdit4->Lines->Add(IntToHex(0,4)+": FF FF FF FF FF FF FF FF   |   ");
            Form1->RichEdit5->Lines->Add(IntToHex(0,4)+": FF FF FF FF FF FF FF FF   |   ");
            Form1->RichEdit6->Lines->Add(IntToHex(0,4)+": FF FF FF FF FF FF FF FF   |   ");
            //     
            Form1->RichEdit4->SelStart=44;
            Form1->RichEdit4->SelLength=2;
            Form1->RichEdit4->SelText="";

            Form1->RichEdit5->SelStart=44;
            Form1->RichEdit5->SelLength=2;
            Form1->RichEdit5->SelText="";

            Form1->RichEdit6->SelStart=44;
            Form1->RichEdit6->SelLength=2;
            Form1->RichEdit6->SelText="";
            //  Status Register
            Form1->Edit4->Text="FF";
            Form1->Edit5->Text="FF";
            Form1->Edit6->Text="FF";
            //  
            Form1->RichEdit4->Visible=true;
            Form1->RichEdit5->Visible=true;
            Form1->RichEdit6->Visible=true;
  }
  PageToUpdate=0;
}
//---------------------------------------------------------------------------
void ChangeLeftRight(int PositionGlobal, int PositionLocal, int LineNumber, char Key)
{ int  TempPositionGlobalR, TempPositionGlobalL;
  bool ChangeLeft, ChangeRight;
  AnsiString TempStr;
  char buf[2], value[1], hexbuf[3];
  unsigned char TempChar;
  char *Charset1="0123456789abcdefABCDEF";

 ChangeLeft=false; ChangeRight=false;
 switch(PositionLocal)
  { case 6: case 7:   TempPositionGlobalR=LineNumber*46+36; //   ,    
                      TempPositionGlobalL=46*LineNumber+6;  //   ,       
                      ChangeLeft=true; //   
                      break;
    case 9: case 10:  TempPositionGlobalR=LineNumber*46+37; //   ,    
                      TempPositionGlobalL=46*LineNumber+9;  //   ,       
                      ChangeLeft=true; //   
                      break;
    case 12: case 13: TempPositionGlobalR=LineNumber*46+38; //   ,    
                      TempPositionGlobalL=46*LineNumber+12; //   ,       
                      ChangeLeft=true; //   
                      break;
    case 15: case 16: TempPositionGlobalR=LineNumber*46+39; //   ,    
                      TempPositionGlobalL=46*LineNumber+15; //   ,       
                      ChangeLeft=true; //   
                      break;
    case 18: case 19: TempPositionGlobalR=LineNumber*46+40; //   ,    
                      TempPositionGlobalL=46*LineNumber+18; //   ,       
                      ChangeLeft=true; //   
                      break;
    case 21: case 22: TempPositionGlobalR=LineNumber*46+41; //   ,    
                      TempPositionGlobalL=46*LineNumber+21; //   ,       
                      ChangeLeft=true; //   
                      break;
    case 24: case 25: TempPositionGlobalR=LineNumber*46+42; //   ,    
                      TempPositionGlobalL=46*LineNumber+24; //   ,       
                      ChangeLeft=true; //   
                      break;
    case 27: case 28: TempPositionGlobalR=LineNumber*46+43; //   ,    
                      TempPositionGlobalL=46*LineNumber+27; //   ,       
                      ChangeLeft=true; //   
                      break;
    case 36: TempPositionGlobalR=LineNumber*46+36; //   ,    
             TempPositionGlobalL=46*LineNumber+6;  //   ,       
             ChangeRight=true; //   
             break;
    case 37: TempPositionGlobalR=LineNumber*46+37; //   ,    
             TempPositionGlobalL=46*LineNumber+9;  //   ,       
             ChangeRight=true; //   
             break;
    case 38: TempPositionGlobalR=LineNumber*46+38; //   ,    
             TempPositionGlobalL=46*LineNumber+12; //   ,       
             ChangeRight=true; //   
             break;
    case 39: TempPositionGlobalR=LineNumber*46+39; //   ,    
             TempPositionGlobalL=46*LineNumber+15; //   ,       
             ChangeRight=true; //   
             break;
    case 40: TempPositionGlobalR=LineNumber*46+40; //   ,    
             TempPositionGlobalL=46*LineNumber+18; //   ,       
             ChangeRight=true; //   
             break;
    case 41: TempPositionGlobalR=LineNumber*46+41; //   ,    
             TempPositionGlobalL=46*LineNumber+21; //   ,       
             ChangeRight=true; //   
             break;
    case 42: TempPositionGlobalR=LineNumber*46+42; //   ,    
             TempPositionGlobalL=46*LineNumber+24; //   ,       
             ChangeRight=true; //   
             break;
    case 43: TempPositionGlobalR=LineNumber*46+43; //   ,    
             TempPositionGlobalL=46*LineNumber+27; //   ,       
             ChangeRight=true; //   
             break;
  }
  bool Choice = (strchr(Charset1,Key))||(BS_FLAG);
  if(ChangeLeft && Choice)
  { //    
    if(Key==0x2E||BS_FLAG==true) Key=0x46;                    //   -   "F"
    switch(Form1->PageControl1->TabIndex)
    { case 0: if(Form1->RichEdit1->Focused())
              { Form1->RichEdit1->SelStart=PositionGlobal;      //     
                Form1->RichEdit1->SelLength=1;                  //  1 
                Form1->RichEdit1->SelText=Key;                  // 
                Form1->RichEdit1->SelStart=PositionGlobal;      //     
                Form1->RichEdit1->SelLength=1;                  //  1 
                Form1->RichEdit1->SelText=UpperCase(Form1->RichEdit1->SelText);//      
                //    
                Form1->RichEdit1->SelStart=TempPositionGlobalL; //     
                Form1->RichEdit1->SelLength=2;                  //  2 
                TempStr=LowerCase(Form1->RichEdit1->SelText);   //    
              }
              else
              { Form1->RichEdit4->SelStart=PositionGlobal;      //     
                Form1->RichEdit4->SelLength=1;                  //  1 
                Form1->RichEdit4->SelText=Key;                  // 
                Form1->RichEdit4->SelStart=PositionGlobal;      //     
                Form1->RichEdit4->SelLength=1;                  //  1 
                Form1->RichEdit4->SelText=UpperCase(Form1->RichEdit4->SelText);//      
                //    
                Form1->RichEdit4->SelStart=TempPositionGlobalL; //     
                Form1->RichEdit4->SelLength=2;                  //  2 
                TempStr=LowerCase(Form1->RichEdit4->SelText);   //    
              }
              break;
      case 1: if(Form1->RichEdit2->Focused())
              { Form1->RichEdit2->SelStart=PositionGlobal;      //     
                Form1->RichEdit2->SelLength=1;                  //  1 
                Form1->RichEdit2->SelText=Key;                  // 
                Form1->RichEdit2->SelStart=PositionGlobal;      //     
                Form1->RichEdit2->SelLength=1;                  //  1 
                Form1->RichEdit2->SelText=UpperCase(Form1->RichEdit2->SelText);//      
                //    
                Form1->RichEdit2->SelStart=TempPositionGlobalL; //     
                Form1->RichEdit2->SelLength=2;                  //  2 
                TempStr=LowerCase(Form1->RichEdit2->SelText);   //    
              }
              else
              { Form1->RichEdit5->SelStart=PositionGlobal;      //     
                Form1->RichEdit5->SelLength=1;                  //  1 
                Form1->RichEdit5->SelText=Key;                  // 
                Form1->RichEdit5->SelStart=PositionGlobal;      //     
                Form1->RichEdit5->SelLength=1;                  //  1 
                Form1->RichEdit5->SelText=UpperCase(Form1->RichEdit5->SelText);//      
                //    
                Form1->RichEdit5->SelStart=TempPositionGlobalL; //     
                Form1->RichEdit5->SelLength=2;                  //  2 
                TempStr=LowerCase(Form1->RichEdit5->SelText);   //    
              }
              break;
      case 2: if(Form1->RichEdit3->Focused())
              { Form1->RichEdit3->SelStart=PositionGlobal;      //     
                Form1->RichEdit3->SelLength=1;                  //  1 
                Form1->RichEdit3->SelText=Key;                  // 
                Form1->RichEdit3->SelStart=PositionGlobal;      //     
                Form1->RichEdit3->SelLength=1;                  //  1 
                Form1->RichEdit3->SelText=UpperCase(Form1->RichEdit3->SelText);//      
                //    
                Form1->RichEdit3->SelStart=TempPositionGlobalL; //     
                Form1->RichEdit3->SelLength=2;                  //  2 
                TempStr=LowerCase(Form1->RichEdit3->SelText);   //    
              }
              else
              { Form1->RichEdit6->SelStart=PositionGlobal;      //     
                Form1->RichEdit6->SelLength=1;                  //  1 
                Form1->RichEdit6->SelText=Key;                  // 
                Form1->RichEdit6->SelStart=PositionGlobal;      //     
                Form1->RichEdit6->SelLength=1;                  //  1 
                Form1->RichEdit6->SelText=UpperCase(Form1->RichEdit6->SelText);//      
                //    
                Form1->RichEdit6->SelStart=TempPositionGlobalL; //     
                Form1->RichEdit6->SelLength=2;                  //  2 
                TempStr=LowerCase(Form1->RichEdit6->SelText);   //    
              }
    }
    memset(buf,0,2);                                //  
    strcat(buf,TempStr.c_str());                    //      (  )
    HexToBin(buf,value,1);                          //    ()
    TempChar=value[0];
    if(TempChar<0x1F) value[0]=0x1F; // 
    switch(Form1->PageControl1->TabIndex)
    { case 0: if(Form1->RichEdit1->Focused())
              { //    
                Form1->RichEdit1->SelStart=TempPositionGlobalR; //     
                Form1->RichEdit1->SelLength=1;                  //  1 
                Form1->RichEdit1->SelText=value[0];             //    value
                //    
                Form1->RichEdit1->SelStart=PositionGlobal;      //     
                Form1->RichEdit1->SelLength=0;                  //  
              }
              else
              { //    
                Form1->RichEdit4->SelStart=TempPositionGlobalR; //     
                Form1->RichEdit4->SelLength=1;                  //  1 
                Form1->RichEdit4->SelText=value[0];             //    value
                //    
                Form1->RichEdit4->SelStart=PositionGlobal;      //     
                Form1->RichEdit4->SelLength=0;                  //  
              }
              break;
      case 1: if(Form1->RichEdit2->Focused())
              { //    
                Form1->RichEdit2->SelStart=TempPositionGlobalR; //     
                Form1->RichEdit2->SelLength=1;                  //  1 
                Form1->RichEdit2->SelText=value[0];             //    value
                //    
                Form1->RichEdit2->SelStart=PositionGlobal;      //     
                Form1->RichEdit2->SelLength=0;                  //  
              }
              else
              { //    
                Form1->RichEdit5->SelStart=TempPositionGlobalR; //     
                Form1->RichEdit5->SelLength=1;                  //  1 
                Form1->RichEdit5->SelText=value[0];             //    value
                //    
                Form1->RichEdit5->SelStart=PositionGlobal;      //     
                Form1->RichEdit5->SelLength=0;                  //  
              }
              break;
      case 2: if(Form1->RichEdit3->Focused())
              { //    
                Form1->RichEdit3->SelStart=TempPositionGlobalR; //     
                Form1->RichEdit3->SelLength=1;                  //  1 
                Form1->RichEdit3->SelText=value[0];             //    value
                //    
                Form1->RichEdit3->SelStart=PositionGlobal;      //     
                Form1->RichEdit3->SelLength=0;                  //  
              }
              else
              { //    
                Form1->RichEdit6->SelStart=TempPositionGlobalR; //     
                Form1->RichEdit6->SelLength=1;                  //  1 
                Form1->RichEdit6->SelText=value[0];             //    value
                //    
                Form1->RichEdit6->SelStart=PositionGlobal;      //     
                Form1->RichEdit6->SelLength=0;                  //  
              }
    }
  }
  if(ChangeRight)
  { if(Key==0x2E||BS_FLAG==true) Key=0xFF;                   //   -   ""
    switch(Form1->PageControl1->TabIndex)
    { case 0: if(Form1->RichEdit1->Focused())
              { //    
                Form1->RichEdit1->SelStart=PositionGlobal;     //     
                Form1->RichEdit1->SelLength=1;                 //  1 
                Form1->RichEdit1->SelText=Key;                 // 
              }
              else
              { //    
                Form1->RichEdit4->SelStart=PositionGlobal;     //     
                Form1->RichEdit4->SelLength=1;                 //  1 
                Form1->RichEdit4->SelText=Key;                 // 
              }
              break;
      case 1: if(Form1->RichEdit2->Focused())
              { //    
                Form1->RichEdit2->SelStart=PositionGlobal;     //     
                Form1->RichEdit2->SelLength=1;                 //  1 
                Form1->RichEdit2->SelText=Key;                 // 
              }
              else
              { //    
                Form1->RichEdit5->SelStart=PositionGlobal;     //     
                Form1->RichEdit5->SelLength=1;                 //  1 
                Form1->RichEdit5->SelText=Key;                 // 
              }
              break;
      case 2: if(Form1->RichEdit3->Focused())
              { //    
                Form1->RichEdit3->SelStart=PositionGlobal;     //     
                Form1->RichEdit3->SelLength=1;                 //  1 
                Form1->RichEdit3->SelText=Key;                 // 
              }
              else
              { //    
                Form1->RichEdit6->SelStart=PositionGlobal;     //     
                Form1->RichEdit6->SelLength=1;                 //  1 
                Form1->RichEdit6->SelText=Key;                 // 
              }
    }
    //   
    value[0]=Key;
    BinToHex(value,hexbuf,1);                      //    ()
    hexbuf[2]=0;                                   //   
    switch(Form1->PageControl1->TabIndex)
    { case 0: if(Form1->RichEdit1->Focused())
              { Form1->RichEdit1->SelStart=TempPositionGlobalL;//     
                Form1->RichEdit1->SelLength=2;                 //  1 
                Form1->RichEdit1->SelText=hexbuf;              //   hexbuf (2   -,    )
                Form1->RichEdit1->SelStart=PositionGlobal;     //    
                Form1->RichEdit1->SelLength=0;                 //  
              }
              else
              { Form1->RichEdit4->SelStart=TempPositionGlobalL;//     
                Form1->RichEdit4->SelLength=2;                 //  1 
                Form1->RichEdit4->SelText=hexbuf;              //   hexbuf (2   -,    )
                Form1->RichEdit4->SelStart=PositionGlobal;     //    
                Form1->RichEdit4->SelLength=0;                 //  
              }
              break;
      case 1: if(Form1->RichEdit2->Focused())
              { Form1->RichEdit2->SelStart=TempPositionGlobalL;//     
                Form1->RichEdit2->SelLength=2;                 //  1 
                Form1->RichEdit2->SelText=hexbuf;              //   hexbuf (2   -,    )
                Form1->RichEdit2->SelStart=PositionGlobal;     //    
                Form1->RichEdit2->SelLength=0;                 //  
              }
              else
              { Form1->RichEdit5->SelStart=TempPositionGlobalL;//     
                Form1->RichEdit5->SelLength=2;                 //  1 
                Form1->RichEdit5->SelText=hexbuf;              //   hexbuf (2   -,    )
                Form1->RichEdit5->SelStart=PositionGlobal;     //    
                Form1->RichEdit5->SelLength=0;                 //  
              }
              break;
      case 2: if(Form1->RichEdit3->Focused())
              { Form1->RichEdit3->SelStart=TempPositionGlobalL;//     
                Form1->RichEdit3->SelLength=2;                 //  1 
                Form1->RichEdit3->SelText=hexbuf;              //   hexbuf (2   -,    )
                Form1->RichEdit3->SelStart=PositionGlobal;     //    
                Form1->RichEdit3->SelLength=0;                 //  
              }
              else
              { Form1->RichEdit6->SelStart=TempPositionGlobalL;//     
                Form1->RichEdit6->SelLength=2;                 //  1 
                Form1->RichEdit6->SelText=hexbuf;              //   hexbuf (2   -,    )
                Form1->RichEdit6->SelStart=PositionGlobal;     //    
                Form1->RichEdit6->SelLength=0;                 //  
              }
    }
  }
}
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{ Form1->AutoSize=true;
  Button1->Enabled=false;
  Button2->Enabled=false;
  Button3->Enabled=true;
  Button4->Enabled=false;
  Button5->Enabled=false;
  Button6->Enabled=false;
  Button7->Enabled=false;
  Button8->Enabled=false;
  Form1->CheckBox1->Enabled=false;
  Form1->CheckBox1->Checked=false;
  Form1->CheckBox2->Enabled=false;
  Form1->CheckBox2->Checked=false;
  Form1->CheckBox3->Enabled=false;
  Form1->CheckBox3->Checked=false;
  SelectedChip.Name="DS2430"; SelectedChip.Model=1; SelectedChip.Size=32;
  PageToUpdate=0;
  BuildDataMemory();
  BuildARegMemory();
  if(FileExists("DS2430.jpg")) Image1->Picture->LoadFromFile("DS2430.jpg");
  else                       { MessageBox(NULL,"   ,\n(   ).  \n ,    \n   radiohlam.ru","Error",MB_OK);
                               Image1->Picture->Bitmap->FreeImage(); }
  StringGrid1->Cells[0][0]="Index";
  StringGrid1->Cells[1][0]="ROM Number";
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button3Click(TObject *Sender)
{ OpenPort();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button4Click(TObject *Sender)
{ ClosePort();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ComboBox1Change(TObject *Sender)
{ //   ,    
  if(Port!=INVALID_HANDLE_VALUE) ClosePort();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Exit1Click(TObject *Sender)
{ if(Port!=INVALID_HANDLE_VALUE) ClosePort();
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::About1Click(TObject *Sender)
{ AboutBox->Show();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::RichEdit1KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{ int  PositionGlobal, LineNumber, PositionLocal;

  switch(PageControl1->TabIndex)
  { case 0: if(Form1->RichEdit1->Focused())
             PositionGlobal=Form1->RichEdit1->SelStart;  //    
            else
             PositionGlobal=Form1->RichEdit4->SelStart;  //    
            break;
    case 1: if(Form1->RichEdit2->Focused())
             PositionGlobal=Form1->RichEdit2->SelStart;  //    
            else
             PositionGlobal=Form1->RichEdit5->SelStart;  //    
            break;
    case 2: if(Form1->RichEdit2->Focused())
             PositionGlobal=Form1->RichEdit3->SelStart;  //    
            else
             PositionGlobal=Form1->RichEdit6->SelStart;  //    
  }
  LineNumber=PositionGlobal/46;               //  ,      44  + CR+LF
  PositionLocal=PositionGlobal-46*LineNumber; //    
  int MaxLineNumber = (SelectedChip.Size-1)/8;//   
  if((Form1->RichEdit4->Focused())|(Form1->RichEdit5->Focused())|(Form1->RichEdit6->Focused()))
  { MaxLineNumber = 0; } //   

  BS_FLAG=false;
  switch(Key)
   { //*********************************************************
     //   BackSpace ***************************
     case 8:  Key=0x25;
              //   
              if(PositionLocal==6)
              { if(LineNumber==0)  PositionGlobal=MaxLineNumber*46+29;
                else               PositionGlobal=(LineNumber-1)*46+29;
                Key=0;
              }
              if(PositionLocal==36)
              { if(LineNumber==0)  PositionGlobal=MaxLineNumber*46+44;
                else               PositionGlobal=(LineNumber-1)*46+44;
                Key=0;
              }
              switch(PageControl1->TabIndex)
              { case 0: if(Form1->RichEdit1->Focused())
                        { Form1->RichEdit1->SelStart=PositionGlobal;   //  
                          Form1->RichEdit1->SelLength=0;               //  
                        }
                        else
                        { Form1->RichEdit4->SelStart=PositionGlobal;   //  
                          Form1->RichEdit4->SelLength=0;               //  
                        }
                        break;
                case 1: if(Form1->RichEdit2->Focused())
                        { Form1->RichEdit2->SelStart=PositionGlobal;   //  
                          Form1->RichEdit2->SelLength=0;               //  
                        }
                        else
                        { Form1->RichEdit5->SelStart=PositionGlobal;   //  
                          Form1->RichEdit5->SelLength=0;               //  
                        }
                        break;
                case 2: if(Form1->RichEdit3->Focused())
                        { Form1->RichEdit3->SelStart=PositionGlobal;   //  
                          Form1->RichEdit3->SelLength=0;               //  
                        }
                        else
                        { Form1->RichEdit6->SelStart=PositionGlobal;   //  
                          Form1->RichEdit6->SelLength=0;               //  
                        }
              }
              //   BackSpace
              BS_FLAG=true;
              return;
     //*********************************************************
     //   Delete ******************************
     case 0x2E: ChangeLeftRight(PositionGlobal, PositionLocal, LineNumber, Key);
                //   
                if(PositionLocal==29)
                { if(LineNumber==MaxLineNumber)  PositionGlobal=5;
                  else                           PositionGlobal=(LineNumber+1)*46+5;
                }
                if(PositionLocal==44)
                { if(LineNumber==MaxLineNumber)  PositionGlobal=35;
                  else                           PositionGlobal=(LineNumber+1)*46+35;
                }
                switch(PageControl1->TabIndex)
                { case 0: if(Form1->RichEdit1->Focused())
                          { Form1->RichEdit1->SelStart=PositionGlobal;   //  
                            Form1->RichEdit1->SelLength=0;               //  
                          }
                          else
                          { Form1->RichEdit4->SelStart=PositionGlobal;   //  
                            Form1->RichEdit4->SelLength=0;               //  
                          }
                          break;
                  case 1: if(Form1->RichEdit2->Focused())
                          { Form1->RichEdit2->SelStart=PositionGlobal;   //  
                            Form1->RichEdit2->SelLength=0;               //  
                          }
                          else
                          { Form1->RichEdit5->SelStart=PositionGlobal;   //  
                            Form1->RichEdit5->SelLength=0;               //  
                          }
                          break;
                  case 2: if(Form1->RichEdit3->Focused())
                          { Form1->RichEdit3->SelStart=PositionGlobal;   //  
                            Form1->RichEdit3->SelLength=0;               //  
                          }
                          else
                          { Form1->RichEdit6->SelStart=PositionGlobal;   //  
                            Form1->RichEdit6->SelLength=0;               //  
                          }
                }
                Key=0x27;
                return;
     //*********************************************************
     //    *****************************
     case 0x25:
     case 0x26:
     case 0x27:
     case 0x28: return;
     //*********************************************************
     //     ***********************
     default:   Key=0;
                return;
   }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::RichEdit1KeyPress(TObject *Sender, char &Key)
{ int  PositionGlobal, LineNumber, PositionLocal;

  switch(PageControl1->TabIndex)
  { case 0: if(Form1->RichEdit1->Focused())
             PositionGlobal=Form1->RichEdit1->SelStart;  //    
            else
             PositionGlobal=Form1->RichEdit4->SelStart;  //    
            break;
    case 1: if(Form1->RichEdit2->Focused())
             PositionGlobal=Form1->RichEdit2->SelStart;  //    
            else
             PositionGlobal=Form1->RichEdit5->SelStart;  //    
            break;
    case 2: if(Form1->RichEdit3->Focused())
             PositionGlobal=Form1->RichEdit3->SelStart;  //    
            else
             PositionGlobal=Form1->RichEdit6->SelStart;  //    
  }
  LineNumber=PositionGlobal/46;               //  ,      44  + CR+LF
  PositionLocal=PositionGlobal-46*LineNumber; //    
  //************************************************************
  //   Enter *****************************************
  if(Key==0x0D)
  { Key=0;     //  Enter
    return;    //  
  }
  //************************************************************
  //   BackSpace     ************
  ChangeLeftRight(PositionGlobal, PositionLocal, LineNumber, Key);
  if(BS_FLAG) return; //    BackSpace
  //  -  ****************************************
  int MaxLineNumber = (SelectedChip.Size-1)/8;
  if((Form1->RichEdit4->Focused())|(Form1->RichEdit5->Focused())|(Form1->RichEdit6->Focused()))
   MaxLineNumber = 0;
  
  if(PositionLocal==29)
  { if(LineNumber==MaxLineNumber)  PositionGlobal=5;
    else                           PositionGlobal=(LineNumber+1)*46+5;
    switch(PageControl1->TabIndex)
    { case 0: if(Form1->RichEdit1->Focused())
              { Form1->RichEdit1->SelStart=PositionGlobal;   //  
                Form1->RichEdit1->SelLength=0;               //  
              }
              else
              { Form1->RichEdit4->SelStart=PositionGlobal;   //  
                Form1->RichEdit4->SelLength=0;               //  
              }
              break;
      case 1: if(Form1->RichEdit2->Focused())
              { Form1->RichEdit2->SelStart=PositionGlobal;   //  
                Form1->RichEdit2->SelLength=0;               //  
              }
              else
              { Form1->RichEdit5->SelStart=PositionGlobal;   //  
                Form1->RichEdit5->SelLength=0;               //  
              }
              break;
      case 2: if(Form1->RichEdit3->Focused())
              { Form1->RichEdit3->SelStart=PositionGlobal;   //  
                Form1->RichEdit3->SelLength=0;               //  
              }
              else
              { Form1->RichEdit6->SelStart=PositionGlobal;   //  
                Form1->RichEdit6->SelLength=0;               //  
              }
    }
  }
  if(PositionLocal==44)
  { if(LineNumber==MaxLineNumber)  PositionGlobal=35;
    else                           PositionGlobal=(LineNumber+1)*46+35;
    switch(PageControl1->TabIndex)
    { case 0: if(Form1->RichEdit1->Focused())
              { Form1->RichEdit1->SelStart=PositionGlobal;   //  
                Form1->RichEdit1->SelLength=0;               //  
              }
              else
              { Form1->RichEdit4->SelStart=PositionGlobal;   //  
                Form1->RichEdit4->SelLength=0;               //  
              }
              break;
      case 1: if(Form1->RichEdit2->Focused())
              { Form1->RichEdit2->SelStart=PositionGlobal;   //  
                Form1->RichEdit2->SelLength=0;               //  
              }
              else
              { Form1->RichEdit5->SelStart=PositionGlobal;   //  
                Form1->RichEdit5->SelLength=0;               //  
              }
              break;
      case 2: if(Form1->RichEdit3->Focused())
              { Form1->RichEdit3->SelStart=PositionGlobal;   //  
                Form1->RichEdit3->SelLength=0;               //  
              }
              else
              { Form1->RichEdit6->SelStart=PositionGlobal;   //  
                Form1->RichEdit6->SelLength=0;               //  
              }
    }
  }
  Key=0;
  keybd_event(VK_RIGHT,0,0,0);
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//***************************************************************************
//---    ----------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{ unsigned char buf[2], value[1];
  AnsiString TempStr;
  int  GlobalNumber, BlockNumber, BlockPosition; //  ,  8- ,   8- 
  int i;

  // -
  Application->CreateForm(__classid(TLBar),&LBar); //    -
  LBar->Show();                   //     

  // Reset
  wr_buf_len=1;
  wr_buf[0]=0x60;
  if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                   LBar->Free();        //    -
                   ClosePort();
                   return;
                 }
  Sleep(1);
  // Match ROM
  wr_buf_len=2;
  wr_buf[0]=0x61;     //SendByte_1W
  wr_buf[1]=0x55;     //Match ROM
  if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                   LBar->Free();        //    -
                   ClosePort();
                   return;
                 }
  Sleep(1);
  // 8  ROM-
  for(i=0; i<8; i++) //   
  { wr_buf_len=2;
    wr_buf[0]=0x61;              //SendByte_1W
    wr_buf[1]=SelectedROM[i];    //ROM Bytes
    if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                     LBar->Free();        //    -
                     ClosePort();
                     return;
                   }
    Sleep(1);
  }
  // Write Scratchpad
  wr_buf_len=2;
  wr_buf[0]=0x61;    //SendByte_1W
  wr_buf[1]=0x0F;    //Write Scratchpad
  if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                   LBar->Free();        //    -
                   ClosePort();
                   return;
                 }
  Sleep(1);
  // 
  wr_buf_len=2;
  wr_buf[0]=0x61;    //SendByte_1W
  wr_buf[1]=0x00;    //Address = 00h
  if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                   LBar->Free();        //    -
                   ClosePort();
                   return;
                 }
  Sleep(1);
  //***********************************************************************
  // WRITE ****************************************************************
  for(i=0; i<SelectedChip.Size; i++) //   
  { wr_buf_len=2;
    wr_buf[0]=0x61;    //SendByte_1W
    // ,    (1 )
    //   
    GlobalNumber=i;    //  ( )
    BlockNumber=GlobalNumber/8;
    BlockPosition=GlobalNumber-BlockNumber*8;
    switch(PageControl1->TabIndex)
    { case 0: Form1->RichEdit1->SelStart=BlockNumber*46+6+3*BlockPosition;//     
              Form1->RichEdit1->SelLength=2;                 //  2 
              TempStr=LowerCase(Form1->RichEdit1->SelText);  //    
              Form1->RichEdit1->SelLength=0;                 //  
              break;
      case 1: Form1->RichEdit2->SelStart=BlockNumber*46+6+3*BlockPosition;//     
              Form1->RichEdit2->SelLength=2;                 //  2 
              TempStr=LowerCase(Form1->RichEdit2->SelText);  //    
              Form1->RichEdit2->SelLength=0;                 //  
              break;
      case 2: Form1->RichEdit3->SelStart=BlockNumber*46+6+3*BlockPosition;//     
              Form1->RichEdit3->SelLength=2;                 //  2 
              TempStr=LowerCase(Form1->RichEdit3->SelText);  //    
              Form1->RichEdit3->SelLength=0;                 //  
    }
    memset(buf,0,2);                               //  
    strcat(buf,TempStr.c_str());                   //      (  )
    HexToBin(buf,value,1);                         //    ()
    //     
    wr_buf[1]=value[0];
    if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                     LBar->Free();        //    -
                     ClosePort();
                     return;
                   }
    //   -
    LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Size; //    -
    // ,     
    Sleep(1);
  }
  //***********************************************************************
  if(Form1->CheckBox2->Checked==true)
  { // Reset
    wr_buf_len=1;
    wr_buf[0]=0x60;
    if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                     LBar->Free();        //    -
                     ClosePort();
                     return;
                   }
    Sleep(1);
    // Match ROM
    wr_buf_len=2;
    wr_buf[0]=0x61;     //SendByte_1W
    wr_buf[1]=0x55;     //Match ROM
    if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                     LBar->Free();        //    -
                     ClosePort();
                     return;
                   }
    Sleep(1);
    // 8  ROM-
    for(i=0; i<8; i++) //   
    { wr_buf_len=2;
      wr_buf[0]=0x61;              //SendByte_1W
      wr_buf[1]=SelectedROM[i];    //ROM Bytes
      if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                       LBar->Free();        //    -
                       ClosePort();
                       return;
                     }
      Sleep(1);
    }
    // Copy Scratchpad
    wr_buf_len=2;
    wr_buf[0]=0x61;    //SendByte_1W
    wr_buf[1]=0x55;    //Copy Scratchpad
    if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                     LBar->Free();        //    -
                     ClosePort();
                     return;
                   }
    Sleep(1);
    // Validation Key
    wr_buf_len=2;
    wr_buf[0]=0x61;    //SendByte_1W
    wr_buf[1]=0xA5;    //Validation Key
    if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                     LBar->Free();        //    -
                     ClosePort();
                     return;
                   }
    Sleep(10);
  }
  LBar->Free();        //    -
  MessageBox(NULL," ","OK",MB_OK);
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//***************************************************************************
//---    ----------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{ char buf[2], value[1], hexbuf[3];
  AnsiString TempStr;
  int  GlobalNumber, BlockNumber, BlockPosition;  //  ,  8- ,   8- 

  // -
  Application->CreateForm(__classid(TLBar),&LBar); //    -
  LBar->Show();                   //     
  // Reset
  wr_buf_len=1;
  wr_buf[0]=0x60;
  if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                   LBar->Free();        //    -
                   ClosePort();
                   return;
                 }
  Sleep(1);
  // Match ROM
  wr_buf_len=2;
  wr_buf[0]=0x61;     //SendByte_1W
  wr_buf[1]=0x55;     //Match ROM
  if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                   LBar->Free();        //    -
                   ClosePort();
                   return;
                 }
  Sleep(1);
  // 8  ROM-
  for(int i=0; i<8; i++) //   
  { wr_buf_len=2;
    wr_buf[0]=0x61;              //SendByte_1W
    wr_buf[1]=SelectedROM[i];    //ROM Bytes
    if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                     LBar->Free();        //    -
                     ClosePort();
                     return;
                   }
    Sleep(1);
  }
  // 
  if(Form1->CheckBox3->Checked==true)  wr_buf[1]=0xF0;    //Read Memory (Copy EPROM to Scratchpad & Read)
  else                                 wr_buf[1]=0xAA;    //Read Scratchpad
  wr_buf_len=2;
  wr_buf[0]=0x61;    //SendByte_1W
  if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                   LBar->Free();        //    -
                   ClosePort();
                   return;
                 }
  Sleep(10);
  // 
  wr_buf_len=2;
  wr_buf[0]=0x61;    //SendByte_1W
  wr_buf[1]=0x00;    //Address = 00h
  if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                   LBar->Free();        //    -
                   ClosePort();
                   return;
                 }
  Sleep(1);
  // READ *******************************************************************
  for(int i=0; i<SelectedChip.Size; i++) //   
  { wr_buf_len=1;
    wr_buf[0]=0x62; //   
    if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                     LBar->Free();        //    -
                     ClosePort();
                     return;
                   }
    Sleep(1);
    // 
    if(!ReadFrom()){ MessageBox(NULL,"  ","Error",MB_OK);
                     LBar->Free();        //    -
                     ClosePort();
                     return;
                   }
    Sleep(1);
    //   -
    LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Size; //    -
    //     (ByteInWord   )
    GlobalNumber=i;  //  ( )
    BlockNumber=GlobalNumber/8;
    BlockPosition=GlobalNumber-BlockNumber*8;
    //   
       memset(buf,0,2);                            //  
       buf[0]=rd_buf[0]; //     
       if(rd_buf[0]<0x1F) buf[0]=0x1F;  //,  
       switch(PageControl1->TabIndex)
       { case 0: Form1->RichEdit1->SelStart=BlockNumber*46+36+BlockPosition; //        
                 Form1->RichEdit1->SelLength=1;           //  1 
                 Form1->RichEdit1->SelText=buf;           //    
                 break;
         case 1: Form1->RichEdit2->SelStart=BlockNumber*46+36+BlockPosition; //        
                 Form1->RichEdit2->SelLength=1;           //  1 
                 Form1->RichEdit2->SelText=buf;           //    
                 break;
         case 2: Form1->RichEdit3->SelStart=BlockNumber*46+36+BlockPosition; //        
                 Form1->RichEdit3->SelLength=1;           //  1 
                 Form1->RichEdit3->SelText=buf;           //    
       }
    //  
     value[0]=rd_buf[0];
     BinToHex(value,hexbuf,1);                       //    ()
       hexbuf[2]=0;                                  //   
       switch(PageControl1->TabIndex)
       { case 0: Form1->RichEdit1->SelStart=BlockNumber*46+6+3*BlockPosition; //     
                 Form1->RichEdit1->SelLength=2;                  //  2 
                 Form1->RichEdit1->SelText=hexbuf;
                 break;
         case 1: Form1->RichEdit2->SelStart=BlockNumber*46+6+3*BlockPosition; //     
                 Form1->RichEdit2->SelLength=2;                  //  2 
                 Form1->RichEdit2->SelText=hexbuf;
                 break;
         case 2: Form1->RichEdit3->SelStart=BlockNumber*46+6+3*BlockPosition; //     
                 Form1->RichEdit3->SelLength=2;                  //  2 
                 Form1->RichEdit3->SelText=hexbuf;
       }
     // ,     
  }
  // Reset   
  wr_buf_len=1;
  wr_buf[0]=0x60;
  if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                   LBar->Free();        //    -
                   ClosePort();
                   return;
                 }
  Sleep(1);
  //*************************************************************************
  LBar->Free();        //    -
  MessageBox(NULL," ","OK",MB_OK);
}
//***************************************************************************
//---------------------------------------------------------------------------
//---  APPLICATION REGISTER -------------------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::Button7Click(TObject *Sender)
{ unsigned char buf[2], value[1];
  AnsiString TempStr;
  int  BlockPosition; //   8- 
  int i;
  bool NeedLock;

  if(Form1->CheckBox1->Checked==true)
  { if(MessageBox(Form1->Handle,"? Application Register    !","", MB_OKCANCEL|MB_ICONQUESTION)==IDOK)
      NeedLock=true;
    else
    { Form1->CheckBox1->Checked=false;
      NeedLock=false;
      MessageBox(NULL,"  COPY&LOCK !","OK",MB_OK);
    }
  }
  else NeedLock=false;

  // -
  Application->CreateForm(__classid(TLBar),&LBar); //    -
  LBar->Show();                   //     

  // Reset
  wr_buf_len=1;
  wr_buf[0]=0x60;
  if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                   LBar->Free();        //    -
                   ClosePort();
                   return;
                 }
  Sleep(1);
  // Match ROM
  wr_buf_len=2;
  wr_buf[0]=0x61;     //SendByte_1W
  wr_buf[1]=0x55;     //Match ROM
  if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                   LBar->Free();        //    -
                   ClosePort();
                   return;
                 }
  Sleep(1);
  // 8  ROM-
  for(i=0; i<8; i++) //   
  { wr_buf_len=2;
    wr_buf[0]=0x61;              //SendByte_1W
    wr_buf[1]=SelectedROM[i];    //ROM Bytes
    if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                     LBar->Free();        //    -
                     ClosePort();
                     return;
                   }
    Sleep(1);
  }
  // Write Application Register
  wr_buf_len=2;
  wr_buf[0]=0x61;    //SendByte_1W
  wr_buf[1]=0x99;    //Write Application Register
  if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                   LBar->Free();        //    -
                   ClosePort();
                   return;
                 }
  Sleep(1);
  // 
  wr_buf_len=2;
  wr_buf[0]=0x61;    //SendByte_1W
  wr_buf[1]=0x00;    //Address = 00h
  if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                   LBar->Free();        //    -
                   ClosePort();
                   return;
                 }
  Sleep(1);
  //***********************************************************************
  // WRITE ****************************************************************
  for(i=0; i<8; i++) //   
  { wr_buf_len=2;
    wr_buf[0]=0x61;    //SendByte_1W
    // ,    (1 )
    //   
    BlockPosition=i;
    switch(PageControl1->TabIndex)
    { case 0: Form1->RichEdit4->SelStart=6+3*BlockPosition;//     
              Form1->RichEdit4->SelLength=2;                 //  2 
              TempStr=LowerCase(Form1->RichEdit4->SelText);  //    
              Form1->RichEdit4->SelLength=0;                 //  
              break;
      case 1: Form1->RichEdit5->SelStart=6+3*BlockPosition;//     
              Form1->RichEdit5->SelLength=2;                 //  2 
              TempStr=LowerCase(Form1->RichEdit5->SelText);  //    
              Form1->RichEdit5->SelLength=0;                 //  
              break;
      case 2: Form1->RichEdit6->SelStart=6+3*BlockPosition;//     
              Form1->RichEdit6->SelLength=2;                 //  2 
              TempStr=LowerCase(Form1->RichEdit6->SelText);  //    
              Form1->RichEdit6->SelLength=0;                 //  
    }
    memset(buf,0,2);                               //  
    strcat(buf,TempStr.c_str());                   //      (  )
    HexToBin(buf,value,1);                         //    ()
    //     
    wr_buf[1]=value[0];
    if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                     LBar->Free();        //    -
                     ClosePort();
                     return;
                   }
    //   -
    LBar->ProgressBar1->Position=100*(i+1)/8; //    -
    // ,     
    Sleep(10);
  }
  //***********************************************************************
  if(NeedLock==true)
  { // Reset
    wr_buf_len=1;
    wr_buf[0]=0x60;
    if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                     LBar->Free();        //    -
                     ClosePort();
                     return;
                   }
    Sleep(1);
    // Match ROM
    wr_buf_len=2;
    wr_buf[0]=0x61;     //SendByte_1W
    wr_buf[1]=0x55;     //Match ROM
    if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                     LBar->Free();        //    -
                     ClosePort();
                     return;
                   }
    Sleep(1);
    // 8  ROM-
    for(i=0; i<8; i++) //   
    { wr_buf_len=2;
      wr_buf[0]=0x61;              //SendByte_1W
      wr_buf[1]=SelectedROM[i];    //ROM Bytes
      if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                       LBar->Free();        //    -
                       ClosePort();
                       return;
                     }
      Sleep(1);
    }
    // Copy&Lock Application Register
    wr_buf_len=2;
    wr_buf[0]=0x61;    //SendByte_1W
    wr_buf[1]=0x5A;    //Copy&Lock Application Register
    if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                     LBar->Free();        //    -
                     ClosePort();
                     return;
                   }
    Sleep(1);
    // Validation Key
    wr_buf_len=2;
    wr_buf[0]=0x61;    //SendByte_1W
    wr_buf[1]=0xA5;    //Validation Key
    if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                     LBar->Free();        //    -
                     ClosePort();
                     return;
                   }
    Sleep(10);
  }
  LBar->Free();        //    -
  MessageBox(NULL," ","OK",MB_OK);
}
//---------------------------------------------------------------------------
//---  APPLICATION REGISTER -------------------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::Button6Click(TObject *Sender)
{ char buf[2], value[1], hexbuf[3];
  AnsiString TempStr;
  int  BlockPosition;  //   8- 

  // -
  Application->CreateForm(__classid(TLBar),&LBar); //    -
  LBar->Show();                   //     
  // Reset
  wr_buf_len=1;
  wr_buf[0]=0x60;
  if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                   LBar->Free();        //    -
                   ClosePort();
                   return;
                 }
  Sleep(1);
  // Match ROM
  wr_buf_len=2;
  wr_buf[0]=0x61;     //SendByte_1W
  wr_buf[1]=0x55;     //Match ROM
  if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                   LBar->Free();        //    -
                   ClosePort();
                   return;
                 }
  Sleep(1);
  // 8  ROM-
  for(int i=0; i<8; i++) //   
  { wr_buf_len=2;
    wr_buf[0]=0x61;              //SendByte_1W
    wr_buf[1]=SelectedROM[i];    //ROM Bytes
    if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                     LBar->Free();        //    -
                     ClosePort();
                     return;
                   }
    Sleep(1);
  }
  //  Application Register
  wr_buf_len=2;
  wr_buf[0]=0x61;    //SendByte_1W
  wr_buf[1]=0xC3;    //Read Application Register
  if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                   LBar->Free();        //    -
                   ClosePort();
                   return;
                 }
  Sleep(10);
  // 
  wr_buf_len=2;
  wr_buf[0]=0x61;    //SendByte_1W
  wr_buf[1]=0x00;    //Address = 00h
  if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                   LBar->Free();        //    -
                   ClosePort();
                   return;
                 }
  Sleep(1);
  // READ *******************************************************************
  for(int i=0; i<8; i++) //   
  { wr_buf_len=1;
    wr_buf[0]=0x62; //   
    if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                     LBar->Free();        //    -
                     ClosePort();
                     return;
                   }
    Sleep(1);
    // 
    if(!ReadFrom()){ MessageBox(NULL,"  ","Error",MB_OK);
                     LBar->Free();        //    -
                     ClosePort();
                     return;
                   }
    Sleep(1);
    //   -
    LBar->ProgressBar1->Position=100*(i+1)/8; //    -
    //     (ByteInWord   )
    BlockPosition=i;
    //   
       memset(buf,0,2);                            //  
       buf[0]=rd_buf[0]; //     
       if(rd_buf[0]<0x1F) buf[0]=0x1F;  //,  
       switch(PageControl1->TabIndex)
       { case 0: Form1->RichEdit4->SelStart=36+BlockPosition; //        
                 Form1->RichEdit4->SelLength=1;           //  1 
                 Form1->RichEdit4->SelText=buf;           //    
                 break;
         case 1: Form1->RichEdit5->SelStart=36+BlockPosition; //        
                 Form1->RichEdit5->SelLength=1;           //  1 
                 Form1->RichEdit5->SelText=buf;           //    
                 break;
         case 2: Form1->RichEdit6->SelStart=36+BlockPosition; //        
                 Form1->RichEdit6->SelLength=1;           //  1 
                 Form1->RichEdit6->SelText=buf;           //    
       }
    //  
     value[0]=rd_buf[0];
     BinToHex(value,hexbuf,1);                       //    ()
       hexbuf[2]=0;                                  //   
       switch(PageControl1->TabIndex)
       { case 0: Form1->RichEdit4->SelStart=6+3*BlockPosition; //     
                 Form1->RichEdit4->SelLength=2;                  //  2 
                 Form1->RichEdit4->SelText=hexbuf;
                 break;
         case 1: Form1->RichEdit5->SelStart=6+3*BlockPosition; //     
                 Form1->RichEdit5->SelLength=2;                  //  2 
                 Form1->RichEdit5->SelText=hexbuf;
                 break;
         case 2: Form1->RichEdit6->SelStart=6+3*BlockPosition; //     
                 Form1->RichEdit6->SelLength=2;                  //  2 
                 Form1->RichEdit6->SelText=hexbuf;
       }
     // ,     
  }
  // Reset   
  wr_buf_len=1;
  wr_buf[0]=0x60;
  if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                   LBar->Free();        //    -
                   ClosePort();
                   return;
                 }
  Sleep(1);
  //*************************************************************************
  LBar->Free();        //    -
  MessageBox(NULL," ","OK",MB_OK);
}
//---------------------------------------------------------------------------
//---  STATUS REGISTER ------------------------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::Button8Click(TObject *Sender)
{ char buf[2], value[1], hexbuf[3];

  // -
  Application->CreateForm(__classid(TLBar),&LBar); //    -
  LBar->Show();                   //     
  // Reset
  wr_buf_len=1;
  wr_buf[0]=0x60;
  if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                   LBar->Free();        //    -
                   ClosePort();
                   return;
                 }
  Sleep(1);
  // Match ROM
  wr_buf_len=2;
  wr_buf[0]=0x61;     //SendByte_1W
  wr_buf[1]=0x55;     //Match ROM
  if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                   LBar->Free();        //    -
                   ClosePort();
                   return;
                 }
  Sleep(1);
  // 8  ROM-
  for(int i=0; i<8; i++) //   
  { wr_buf_len=2;
    wr_buf[0]=0x61;              //SendByte_1W
    wr_buf[1]=SelectedROM[i];    //ROM Bytes
    if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                     LBar->Free();        //    -
                     ClosePort();
                     return;
                   }
    Sleep(1);
  }
  //  Status Register
  wr_buf_len=2;
  wr_buf[0]=0x61;    //SendByte_1W
  wr_buf[1]=0x66;    //Read Application Register
  if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                   LBar->Free();        //    -
                   ClosePort();
                   return;
                 }
  Sleep(1);
  // Validation Key
  wr_buf_len=2;
  wr_buf[0]=0x61;    //SendByte_1W
  wr_buf[1]=0x00;    //Validation Key = 00h
  if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                   LBar->Free();        //    -
                   ClosePort();
                   return;
                 }
  Sleep(1);
  // READ *******************************************************************
  wr_buf_len=1;
  wr_buf[0]=0x62; //   
  if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                   LBar->Free();        //    -
                   ClosePort();
                   return;
                 }
  Sleep(1);
  // 
  if(!ReadFrom()){ MessageBox(NULL,"  ","Error",MB_OK);
                   LBar->Free();        //    -
                   ClosePort();
                   return;
                 }
  Sleep(1);
  //   -
  LBar->ProgressBar1->Position=50; //    -
  //    
  value[0]=rd_buf[0];
  BinToHex(value,hexbuf,1);                     //    ()
  hexbuf[2]=0;                                  //   
  switch(PageControl1->TabIndex)
  { case 0: Form1->Edit4->Text=hexbuf;
            break;
    case 1: Form1->Edit5->Text=hexbuf;
            break;
    case 2: Form1->Edit6->Text=hexbuf;
  }

  // Reset
  wr_buf_len=1;
  wr_buf[0]=0x60;
  if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                   LBar->Free();        //    -
                   ClosePort();
                   return;
                 }
  Sleep(1);
  //*************************************************************************
  LBar->Free();        //    -
  MessageBox(NULL," ","OK",MB_OK);
}
//***************************************************************************
//---------------------------------------------------------------------------
//---     ------------------------------------------
//---------------------------------------------------------------------------
//---  -------------------------------------------------------------
void __fastcall TForm1::Open1Click(TObject *Sender)
{ int Namelength; AnsiString Ext;
  char buf[2], value[1], hexbuf[3]; unsigned char rffch[1]; // readed from file char
  AnsiString TempStr;
  int  BlockNumber, BlockPosition;  //  ,  8- ,   8- 

  if(OpenDialog1->Execute())
  { DataFilePath=OpenDialog1->FileName;          //    
    Namelength=DataFilePath.Length();            //      
    Ext=DataFilePath.SubString(Namelength-2,3);  // 
    Ext=UpperCase(Ext);                      //    

    // ,     
    switch(PageControl1->TabIndex)
    { case 0: PageToUpdate=1;
              break;
      case 1: PageToUpdate=2;
              break;
      case 2: PageToUpdate=3;
    }
    BuildDataMemory();
    //  bin-
    TFileStream* fs=new TFileStream(DataFilePath,fmOpenRead);
    for(int i=0; i<SelectedChip.Size; i++)
    { BlockNumber=i/8; BlockPosition=i-BlockNumber*8;
      if(fs->Read(rffch,1))  //    
      { //   
        memset(buf,0,2);             //  
        buf[0]=rffch[0];                //     
        if(rffch[0]<0x1F) buf[0]=0x1F;  //,  
        switch(PageControl1->TabIndex)
        { case 0: Form1->RichEdit1->SelStart=BlockNumber*46+36+BlockPosition; //        
                  Form1->RichEdit1->SelLength=1;           //  1 
                  Form1->RichEdit1->SelText=buf;           //    
                  break;
          case 1: Form1->RichEdit2->SelStart=BlockNumber*46+36+BlockPosition; //        
                  Form1->RichEdit2->SelLength=1;           //  1 
                  Form1->RichEdit2->SelText=buf;           //    
                  break;
          case 2: Form1->RichEdit3->SelStart=BlockNumber*46+36+BlockPosition; //        
                  Form1->RichEdit3->SelLength=1;           //  1 
                  Form1->RichEdit3->SelText=buf;           //    
        }
        //  
        value[0]=rffch[0];
        BinToHex(value,hexbuf,1);                       //    ()
        hexbuf[2]=0;                                    //   
        switch(PageControl1->TabIndex)
        { case 0: Form1->RichEdit1->SelStart=BlockNumber*46+6+3*BlockPosition; //     
                  Form1->RichEdit1->SelLength=2;                  //  2 
                  Form1->RichEdit1->SelText=hexbuf;
                  break;
          case 1: Form1->RichEdit2->SelStart=BlockNumber*46+6+3*BlockPosition; //     
                  Form1->RichEdit2->SelLength=2;                  //  2 
                  Form1->RichEdit2->SelText=hexbuf;
                  break;
          case 2: Form1->RichEdit3->SelStart=BlockNumber*46+6+3*BlockPosition; //     
                  Form1->RichEdit3->SelLength=2;                  //  2 
                  Form1->RichEdit3->SelText=hexbuf;
        }
      }
      else i=SelectedChip.Size; //   
    }
    Form1->StaticText1->Caption="Data Memory file: "+DataFilePath;
    delete fs;
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::OpenApplicationRegister1Click(TObject *Sender)
{ int Namelength; AnsiString Ext;
  char buf[2], value[1], hexbuf[3]; unsigned char rffch[1]; // readed from file char
  AnsiString TempStr;
  int  BlockPosition;  //   8- 

  if(OpenDialog1->Execute())
  { ARegisterFilePath=OpenDialog1->FileName;          //    
    Namelength=ARegisterFilePath.Length();            //      
    Ext=ARegisterFilePath.SubString(Namelength-2,3);  // 
    Ext=UpperCase(Ext);                      //    

    // ,     
    switch(PageControl1->TabIndex)
    { case 0: PageToUpdate=1;
              break;
      case 1: PageToUpdate=2;
              break;
      case 2: PageToUpdate=3;
    }
    BuildARegMemory();
    //  bin-
    TFileStream* fs=new TFileStream(ARegisterFilePath,fmOpenRead);
    for(int i=0; i<8; i++)
    { BlockPosition=i;
      if(fs->Read(rffch,1))  //    
      { //   
        memset(buf,0,2);                //  
        buf[0]=rffch[0];                //     
        if(rffch[0]<0x1F) buf[0]=0x1F;  //,  
        switch(PageControl1->TabIndex)
        { case 0: Form1->RichEdit4->SelStart=36+BlockPosition; //        
                  Form1->RichEdit4->SelLength=1;           //  1 
                  Form1->RichEdit4->SelText=buf;           //    
                  break;
          case 1: Form1->RichEdit5->SelStart=36+BlockPosition; //        
                  Form1->RichEdit5->SelLength=1;           //  1 
                  Form1->RichEdit5->SelText=buf;           //    
                  break;
          case 2: Form1->RichEdit6->SelStart=36+BlockPosition; //        
                  Form1->RichEdit6->SelLength=1;           //  1 
                  Form1->RichEdit6->SelText=buf;           //    
        }
        //  
        value[0]=rffch[0];
        BinToHex(value,hexbuf,1);                       //    ()
        hexbuf[2]=0;                                    //   
        switch(PageControl1->TabIndex)
        { case 0: Form1->RichEdit4->SelStart=6+3*BlockPosition; //     
                  Form1->RichEdit4->SelLength=2;                  //  2 
                  Form1->RichEdit4->SelText=hexbuf;
                  break;
          case 1: Form1->RichEdit5->SelStart=6+3*BlockPosition; //     
                  Form1->RichEdit5->SelLength=2;                  //  2 
                  Form1->RichEdit5->SelText=hexbuf;
                  break;
          case 2: Form1->RichEdit6->SelStart=6+3*BlockPosition; //     
                  Form1->RichEdit6->SelLength=2;                  //  2 
                  Form1->RichEdit6->SelText=hexbuf;
        }
      }
      else i=8; //   
    }
    Form1->StaticText2->Caption="Application Register file: "+ARegisterFilePath;
    delete fs;
  }
}
//---------------------------------------------------------------------------
//---  -------------------------------------------------------------
void __fastcall TForm1::Saveas1Click(TObject *Sender)
{ char buf[2], value[1];
  AnsiString TempStr;
  int  BlockNumber, BlockPosition;  //  ,  8- ,   8- 

  if(SaveDialog1->Execute()) //     
  { TFileStream* fs=new TFileStream(SaveDialog1->FileName,fmCreate|fmOpenWrite);
    DataFilePath=SaveDialog1->FileName;
    for(int i=0; i<SelectedChip.Size; i++)
    { BlockNumber=i/8; BlockPosition=i-BlockNumber*8;
      switch(PageControl1->TabIndex)
      { case 0: Form1->RichEdit1->SelStart=BlockNumber*46+6+3*BlockPosition;//     
                Form1->RichEdit1->SelLength=2;                 //  2 
                TempStr=LowerCase(Form1->RichEdit1->SelText);  //    
                Form1->RichEdit1->SelLength=0;                 //  
                break;
        case 1: Form1->RichEdit2->SelStart=BlockNumber*46+6+3*BlockPosition;//     
                Form1->RichEdit2->SelLength=2;                 //  2 
                TempStr=LowerCase(Form1->RichEdit2->SelText);  //    
                Form1->RichEdit2->SelLength=0;                 //  
                break;
        case 2: Form1->RichEdit3->SelStart=BlockNumber*46+6+3*BlockPosition;//     
                Form1->RichEdit3->SelLength=2;                 //  2 
                TempStr=LowerCase(Form1->RichEdit3->SelText);  //    
                Form1->RichEdit3->SelLength=0;                 //  
      }
      memset(buf,0,2);                               //  
      strcat(buf,TempStr.c_str());                   //      (  )
      HexToBin(buf,value,1);                         //    ()
      fs->Write(value,1);                            //  
    }
    Form1->StaticText1->Caption="Data Memory file: "+DataFilePath;
    delete fs;
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SaveApplicationRegisterAs1Click(TObject *Sender)
{ char buf[2], value[1];
  AnsiString TempStr;
  int  BlockPosition;  //   8- 

  if(SaveDialog1->Execute()) //     
  { TFileStream* fs=new TFileStream(SaveDialog1->FileName,fmCreate|fmOpenWrite);
    ARegisterFilePath=SaveDialog1->FileName;
    for(int i=0; i<8; i++)
    { BlockPosition=i;
      switch(PageControl1->TabIndex)
      { case 0: Form1->RichEdit4->SelStart=6+3*BlockPosition;//     
                Form1->RichEdit4->SelLength=2;                 //  2 
                TempStr=LowerCase(Form1->RichEdit4->SelText);  //    
                Form1->RichEdit4->SelLength=0;                 //  
                break;
        case 1: Form1->RichEdit5->SelStart=6+3*BlockPosition;//     
                Form1->RichEdit5->SelLength=2;                 //  2 
                TempStr=LowerCase(Form1->RichEdit5->SelText);  //    
                Form1->RichEdit5->SelLength=0;                 //  
                break;
        case 2: Form1->RichEdit6->SelStart=6+3*BlockPosition;//     
                Form1->RichEdit6->SelLength=2;                 //  2 
                TempStr=LowerCase(Form1->RichEdit6->SelText);  //    
                Form1->RichEdit6->SelLength=0;                 //  
      }
      memset(buf,0,2);                               //  
      strcat(buf,TempStr.c_str());                   //      (  )
      HexToBin(buf,value,1);                         //    ()
      fs->Write(value,1);                            //  
    }
    Form1->StaticText2->Caption="Application Register file: "+ARegisterFilePath;
    delete fs;
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Save1Click(TObject *Sender)
{ char buf[2], value[1];  int Namelength;
  AnsiString TempStr, Ext;
  int  BlockNumber, BlockPosition;  //  ,  8- ,   8- 
  TFileStream* fs;
  bool NeedSave;

  NeedSave=false;
  Namelength=DataFilePath.Length();            //      
  Ext=DataFilePath.SubString(Namelength-2,3);  // 
  Ext=UpperCase(Ext);                      //    

  if(DataFilePath.Length()&&(Ext=="BIN"))      //     
  { if(MessageBox(Form1->Handle,"   , ?","", MB_OKCANCEL|MB_ICONQUESTION)==IDOK)
    { fs=new TFileStream(DataFilePath,fmCreate|fmOpenWrite);
      NeedSave=true;
    }
  }
  else if(SaveDialog1->Execute()) //     (  )
  { fs=new TFileStream(SaveDialog1->FileName,fmCreate|fmOpenWrite);
    DataFilePath=SaveDialog1->FileName;
    NeedSave=true;
  }
  if(NeedSave)         //   
  { for(int i=0; i<SelectedChip.Size; i++)
    { BlockNumber=i/8; BlockPosition=i-BlockNumber*8;
      switch(PageControl1->TabIndex)
      { case 0: Form1->RichEdit1->SelStart=BlockNumber*46+6+3*BlockPosition;//     
                Form1->RichEdit1->SelLength=2;                 //  2 
                TempStr=LowerCase(Form1->RichEdit1->SelText);  //    
                Form1->RichEdit1->SelLength=0;                 //  
                break;
        case 1: Form1->RichEdit2->SelStart=BlockNumber*46+6+3*BlockPosition;//     
                Form1->RichEdit2->SelLength=2;                 //  2 
                TempStr=LowerCase(Form1->RichEdit2->SelText);  //    
                Form1->RichEdit2->SelLength=0;                 //  
                break;
        case 2: Form1->RichEdit3->SelStart=BlockNumber*46+6+3*BlockPosition;//     
                Form1->RichEdit3->SelLength=2;                 //  2 
                TempStr=LowerCase(Form1->RichEdit3->SelText);  //    
                Form1->RichEdit3->SelLength=0;                 //  
      }
      memset(buf,0,2);                               //  
      strcat(buf,TempStr.c_str());                   //      (  )
      HexToBin(buf,value,1);                         //    ()
      fs->Write(value,1);                            //  
    }
    Form1->StaticText1->Caption="Data Memory file: "+DataFilePath;
    delete fs;
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SaveApplicationRegister1Click(TObject *Sender)
{ char buf[2], value[1];  int Namelength;
  AnsiString TempStr, Ext;
  int BlockPosition;  //   8- 
  TFileStream* fs;
  bool NeedSave;

  NeedSave=false;
  Namelength=ARegisterFilePath.Length();            //      
  Ext=ARegisterFilePath.SubString(Namelength-2,3);  // 
  Ext=UpperCase(Ext);                      //    

  if(ARegisterFilePath.Length()&&(Ext=="BIN"))      //     
  { if(MessageBox(Form1->Handle,"   , ?","", MB_OKCANCEL|MB_ICONQUESTION)==IDOK)
    { fs=new TFileStream(ARegisterFilePath,fmCreate|fmOpenWrite);
      NeedSave=true;
    }
  }
  else if(SaveDialog1->Execute()) //     (  )
  { fs=new TFileStream(SaveDialog1->FileName,fmCreate|fmOpenWrite);
    ARegisterFilePath=SaveDialog1->FileName;
    NeedSave=true;
  }
  if(NeedSave)         //   
  { for(int i=0; i<8; i++)
    { BlockPosition=i;
      switch(PageControl1->TabIndex)
      { case 0: Form1->RichEdit4->SelStart=6+3*BlockPosition;//     
                Form1->RichEdit4->SelLength=2;                 //  2 
                TempStr=LowerCase(Form1->RichEdit4->SelText);  //    
                Form1->RichEdit4->SelLength=0;                 //  
                break;
        case 1: Form1->RichEdit5->SelStart=6+3*BlockPosition;//     
                Form1->RichEdit5->SelLength=2;                 //  2 
                TempStr=LowerCase(Form1->RichEdit5->SelText);  //    
                Form1->RichEdit5->SelLength=0;                 //  
                break;
        case 2: Form1->RichEdit6->SelStart=6+3*BlockPosition;//     
                Form1->RichEdit6->SelLength=2;                 //  2 
                TempStr=LowerCase(Form1->RichEdit6->SelText);  //    
                Form1->RichEdit6->SelLength=0;                 //  
      }
      memset(buf,0,2);                               //  
      strcat(buf,TempStr.c_str());                   //      (  )
      HexToBin(buf,value,1);                         //    ()
      fs->Write(value,1);                            //  
    }
    Form1->StaticText2->Caption="Application Register file: "+ARegisterFilePath;
    delete fs;
  }
}
//***************************************************************************
//---------------------------------------------------------------------------
//---     -----------------------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::Button5Click(TObject *Sender)
{ //SEARCH DEVICES
  unsigned char CRC, ROM[8], Poly, Temp;
  char buf[2], value[1], hexbuf[3];
  bool SlaveBit, ISlaveBit, LastDev;
  int Step, LastFork, ZeroFork, CurrentByte, CurrentBit;
  AnsiString TempStr;

  //
  Poly=0x31; DevCounter=0;
  Edit2->Text=IntToStr(DevCounter);
  StringGrid1->RowCount=DevCounter+2; //    
  StringGrid1->Cells[0][1]="";
  StringGrid1->Cells[1][1]="";

  for(int i=0; i<8; i++)
  { ROM[i]=0; }  //  ROM
  LastDev=false;
  LastFork=-1;
  // -
  Application->CreateForm(__classid(TLBar),&LBar); //    -
  LBar->Show();                   //     

  while(!LastDev) //     
  { CRC=0; ZeroFork=-1; Step=0;
    // Reset
    wr_buf_len=1;
    wr_buf[0]=0x60;
    if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                     LBar->Free();        //    -
                     ClosePort();
                     return;
                   }
    Sleep(1);
    // Search ROM
    wr_buf_len=2;
    wr_buf[0]=0x61;     //SendByte_1W
    wr_buf[1]=0xF0;     //Search ROM
    if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                     LBar->Free();        //    -
                     ClosePort();
                     return;
                   }
    Sleep(1);
    while(Step<64) //       (64 )
    { CurrentByte=Step/8; CurrentBit=Step-8*CurrentByte;
      //    
      wr_buf_len=1;
      wr_buf[0]=0x64; //   
      if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                       LBar->Free();        //    -
                       ClosePort();
                       return;
                     }
      Sleep(1);
      // 
      if(!ReadFrom()){ MessageBox(NULL,"  ","Error",MB_OK);
                       LBar->Free();        //    -
                       ClosePort();
                       return;
                     }
      if(rd_buf[0]==0x0F) SlaveBit=false;
      else                SlaveBit=true;
      //    
      wr_buf_len=1;
      wr_buf[0]=0x64; //   
      if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                       LBar->Free();        //    -
                       ClosePort();
                       return;
                     }
      Sleep(1);
      // 
      if(!ReadFrom()){ MessageBox(NULL,"  ","Error",MB_OK);
                       LBar->Free();        //    -
                       ClosePort();
                       return;
                     }
      if(rd_buf[0]==0x0F) ISlaveBit=false;
      else                ISlaveBit=true;
      //    ?
      if(SlaveBit==ISlaveBit)  //   -   
      { if (SlaveBit)          //  SlaveBit=1 ()
        { MessageBox(NULL,",     ","Error",MB_OK);
          LBar->Free();        //    -
          ClosePort();
          return;
        }
        else                   //  SlaveBit=0 ()
        { if(Step==LastFork)
          { wr_buf[1]=1; }     // MasterBit=1
          else
          { if(Step>LastFork)
            { wr_buf[1]=0; }
            else
            { wr_buf[1]=ROM[CurrentByte]>>CurrentBit; }
            if((wr_buf[1]&1)==0)    //  MasterBit=0
            { ZeroFork=Step; }
          }
        }
      }
      else //    (  )
      { wr_buf[1]=SlaveBit; }  // MasterBit=SlaveBit

      //    ROM
     Temp=1<<CurrentBit;                     //  =1
      Temp=~Temp;                             // 
      ROM[CurrentByte]=ROM[CurrentByte]&Temp; //   
      Temp=(wr_buf[1]&1)<<CurrentBit;         //  =MasterBit
      ROM[CurrentByte]=ROM[CurrentByte]|Temp; //  MasterBit
      // CRC
      Temp=CRC&0x80; //  
      CRC<<1;        //  CRC 
      if(Temp)       //   =1
       CRC=CRC^Poly;
      //   
      wr_buf_len=2;
      wr_buf[0]=0x63;
      if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                       LBar->Free();        //    -
                       ClosePort();
                       return;
                     }
      Sleep(1);
      Step=Step+1;
      //   -
      LBar->ProgressBar1->Position=100*Step/64; //    -
    }
    //   
    LastFork=ZeroFork;
    if(LastFork<0)
     LastDev=true;
    if(CRC==0)
    { DevCounter=DevCounter+1;            //    
      Edit2->Text=IntToStr(DevCounter);
      StringGrid1->RowCount=DevCounter+1; //    
      TempStr="";
      for(int i=0; i<8; i++)
      {  value[0]=ROM[i];
         BinToHex(value,hexbuf,1);       //   
         hexbuf[2]=0;                    //   
         TempStr=TempStr+hexbuf+" ";
      }
      StringGrid1->Cells[0][DevCounter]=IntToStr(DevCounter);
      StringGrid1->Cells[1][DevCounter]=TempStr;
    }
    else
    { MessageBox(NULL," CRC","Error",MB_OK);
      LBar->Free();        //    -
      ClosePort();
      return;
    }
  }
  //*************************************************************************
  LBar->Free();        //    -
  MessageBox(NULL," ","OK",MB_OK);
}
//---------------------------------------------------------------------------
//---      -----------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::Select1Click(TObject *Sender)
{ int CurrentRow;
  unsigned char buf[2], value[1];
  AnsiString StringROM, SubStr;

  CurrentRow=StringGrid1->Row; //    
  if((CurrentRow>0)&&(StringGrid1->Cells[0][CurrentRow]!=""))
  { StringROM=StringGrid1->Cells[1][CurrentRow];
    Edit3->Text=StringROM;
    for(int i=0; i<8; i++)
    { SubStr=StringROM.SubString(3*i+1,2);
      memset(buf,0,2);                           //  
      strcat(buf,SubStr.c_str());                //      (  )
      HexToBin(buf,value,1);                     //    ()
      SelectedROM[i]=value[0];
    }
  }
  else
  { MessageBox(NULL,"  ,  ROM","Error",MB_OK);
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CheckBox1Click(TObject *Sender)
{ if(Form1->CheckBox1->Checked==false)
   { Form1->Label12->Left=80;
     Form1->Label12->Caption="Write only";
   }
  else
   { Form1->Label12->Left=32;
     Form1->Label12->Caption="Write + Copy && Lock";
   }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CheckBox2Click(TObject *Sender)
{ if(Form1->CheckBox2->Checked==false)
   { Form1->Label13->Left=24;
     Form1->Label13->Caption="Write Scratchpad only";
   }
  else
   { Form1->Label13->Left=16;
     Form1->Label13->Caption="Write && copy to EPROM";
   }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CheckBox3Click(TObject *Sender)
{ if(Form1->CheckBox3->Checked==false)
   { Form1->Label14->Left=24;
     Form1->Label14->Caption="Read Scratchpad only";
   }
  else
   { Form1->Label14->Left=62;
     Form1->Label14->Caption="Read EPROM";
   }
}
//---------------------------------------------------------------------------

